WriterPlsParser Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
WriterPlsParser Class Reference

the main class to read a Writerperfect file More...

`#include <WriterPlsParser.hxx>`

Inheritance diagram for WriterPlsParser:

## Public Member Functions
| WriterPlsParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~WriterPlsParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | readPrintInfo ()
| read the print info zone More...
bool | readWindowsInfo (int zone)
| read the main info for zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER ) More...
bool | sendWindow (int zone, MWAWVec2i limits=MWAWVec2i(-1,-1))
| send a zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER ) More...
bool | readWindowsZone (int zone)
| read the page info zone More...
bool | readPageInfo (int zone)
| read the page info zone More...
bool | readColInfo (int zone)
| read the col info zone ? More...
bool | readParagraphInfo (int zone)
| read the paragraph info zone More...
bool | findSection (int zone, MWAWVec2i limits, MWAWSection &sec)
| try to find the data which correspond to a section ( mainly column ) More...
bool | readSection (WriterPlsParserInternal::ParagraphInfo const &info, bool mainBlock)
| read a section More...
bool | readText (WriterPlsParserInternal::ParagraphInfo const &info)
| read a text More...
bool | readTable (WriterPlsParserInternal::ParagraphInfo const &info)
| read a table More...
bool | readGraphic (WriterPlsParserInternal::ParagraphInfo const &info)
| read a graphic More...
bool | readUnknown (WriterPlsParserInternal::ParagraphInfo const &info)
| read a unknown section More...
double | getTextHeight () const
| returns the page height, ie. paper size less margin (in inches) and header/footer More...
void | newPage (int number)
| adds a new page More...
bool | readParagraphData (WriterPlsParserInternal::ParagraphInfo const &info, bool hasFonts, WriterPlsParserInternal::ParagraphData &data)
| reads a paragraph data More...
MWAWParagraph | getParagraph (WriterPlsParserInternal::ParagraphData const &data)
| returns a paragraph corresponding to a paragraph data More...
bool | readFonts (int nFonts, int type, std::vector< WriterPlsParserInternal::Font > &fonts)
| reads a list of font (with position) More...
bool | readLines (WriterPlsParserInternal::ParagraphInfo const &info, int nLines, std::vector< WriterPlsParserInternal::Line > &lines)
| reads a list of line (with position) More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
shared_ptr< WriterPlsParserInternal::State > | m_state
| the state More...

## Friends
class | WriterPlsParserInternal::SubDocument

## Detailed Description

the main class to read a Writerperfect file

## Constructor & Destructor Documentation

WriterPlsParser::WriterPlsParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

WriterPlsParser::~WriterPlsParser | ( |  | ) |
| virtual

destructor

## Member Function Documentation

bool WriterPlsParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void WriterPlsParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

bool WriterPlsParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

bool WriterPlsParser::findSection | ( | int | zone,
|  | MWAWVec2i | limits,
|  | MWAWSection & | sec
| ) |  |
| protected

try to find the data which correspond to a section ( mainly column )

Referenced by sendWindow().

MWAWParagraph WriterPlsParser::getParagraph | ( | WriterPlsParserInternal::ParagraphData const & | data | ) |
| protected

returns a paragraph corresponding to a paragraph data

Referenced by readText().

double WriterPlsParser::getTextHeight | ( |  | ) | const
| protected

returns the page height, ie. paper size less margin (in inches) and header/footer

Referenced by readPageInfo().

void WriterPlsParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by WriterPlsParser().

void WriterPlsParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by sendWindow().

void WriterPlsParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| virtual

virtual function used to parse the input

Implements MWAWTextParser.

bool WriterPlsParser::readColInfo | ( | int | zone | ) |
| protected

read the col info zone ?

Referenced by readWindowsZone().

bool WriterPlsParser::readFonts | ( | int | nFonts,
|  | int | type,
|  | std::vector< WriterPlsParserInternal::Font > & | fonts
| ) |  |
| protected

reads a list of font (with position)

Referenced by readParagraphData().

bool WriterPlsParser::readGraphic | ( | WriterPlsParserInternal::ParagraphInfo const & | info | ) |
| protected

read a graphic

Referenced by sendWindow().

bool WriterPlsParser::readLines | ( | WriterPlsParserInternal::ParagraphInfo const & | info,
|  | int | nLines,
|  | std::vector< WriterPlsParserInternal::Line > & | lines
| ) |  |
| protected

reads a list of line (with position)

Referenced by readText().

bool WriterPlsParser::readPageInfo | ( | int | zone | ) |
| protected

read the page info zone

Referenced by readWindowsZone().

bool WriterPlsParser::readParagraphData | ( | WriterPlsParserInternal::ParagraphInfo const & | info,
|  | bool | hasFonts,
|  | WriterPlsParserInternal::ParagraphData & | data
| ) |  |
| protected

reads a paragraph data

Referenced by readGraphic(), readSection(), readTable(), readText(), and readUnknown().

bool WriterPlsParser::readParagraphInfo | ( | int | zone | ) |
| protected

read the paragraph info zone

Referenced by readWindowsZone().

bool WriterPlsParser::readPrintInfo | ( |  | ) |
| protected

read the print info zone

Referenced by createZones().

bool WriterPlsParser::readSection | ( | WriterPlsParserInternal::ParagraphInfo const & | info,
|  | bool | mainBlock
| ) |  |
| protected

read a section

Referenced by sendWindow().

bool WriterPlsParser::readTable | ( | WriterPlsParserInternal::ParagraphInfo const & | info | ) |
| protected

read a table

Referenced by sendWindow().

bool WriterPlsParser::readText | ( | WriterPlsParserInternal::ParagraphInfo const & | info | ) |
| protected

read a text

Referenced by sendWindow().

bool WriterPlsParser::readUnknown | ( | WriterPlsParserInternal::ParagraphInfo const & | info | ) |
| protected

read a unknown section

Referenced by sendWindow().

bool WriterPlsParser::readWindowsInfo | ( | int | zone | ) |
| protected

read the main info for zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER )

Referenced by checkHeader(), and createZones().

bool WriterPlsParser::readWindowsZone | ( | int | zone | ) |
| protected

read the page info zone

Referenced by createZones().

bool WriterPlsParser::sendWindow | ( | int | zone,
|  | MWAWVec2i | limits = `MWAWVec2i(-1,-1)`
| ) |  |
| protected

send a zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER )

Referenced by parse(), and WriterPlsParserInternal::SubDocument::parse().

## Friends And Related Function Documentation

friend class WriterPlsParserInternal::SubDocument
| friend

## Member Data Documentation

shared_ptr<WriterPlsParserInternal::State> WriterPlsParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), findSection(), getTextHeight(), init(), newPage(), readColInfo(), readPageInfo(), readParagraphInfo(), readWindowsInfo(), readWindowsZone(), and sendWindow().

The documentation for this class was generated from the following files:

- WriterPlsParser.hxx
- WriterPlsParser.cxx